#python create hidden markov model profile
#check sequence


#from Bio import SeqIO
import numpy
import math
import argparse
import sys
import os
from Bio.Align.Applications import ClustalwCommandline
from Bio import Seq
from Bio import SeqIO
from Bio import AlignIO
from Bio.SeqRecord import SeqRecord
# from Bio.SeqRecord import alphabet
from Bio import SeqIO
import Bio.Alphabet as alpha
# from Bio.Alphabet import Alphabet
import threading
import time
import subprocess
import argparse
import sys

#clustal_loc=r"D:\Program Files (x86)\ClustalW2\clustalw2.exe"
clustal_loc=r"/usr/bin/clustalw"


class hmmThread (threading.Thread):
    def __init__(self, threadID, name, commandID,command):
		threading.Thread.__init__(self)
		self.threadID = threadID
		self.name = name
		self.commandID = commandID
		self.command = command
    def run(self):
		print "Starting $ " + self.name
		if self.commandID == 1:
			print self.command
			subprocess.call(self.command, shell=True)
		if self.commandID == 2:
			print self.command
			subprocess.call(self.command, shell=True)



def convertClustalToFastaBEFOREHEMMER(file):
	handle = open(file, "rU")
	ptr2 = list(SeqIO.parse(handle, "clustal"))
	handle.close()
	#bestAlignRepeats.sort(key=lambda window: int(window.id.split("-")[0]))
	outfile = file
	handle = open(outfile, "w")
	SeqIO.write(ptr2, handle, "fasta")
	handle.close()

def alignClustal(f_in,f_out):
	try:
		#f_in= "%s%s%d.fasta" % (dir,proteinName,possibleStartingPoints[xx][1])
		# print f_in
		#f_out= "%s%s%d.aln" % (dir,proteinName,possibleStartingPoints[xx][1])
		fh= open(f_in)
		fo=open(f_out,'w')
		# for record in SeqIO.parse(fh,"fasta"):
				# id = record.id
				# seq = record.seq
				# print("Name: %s, size: %s is %s "%(id,len(seq), seq))
		try:
				cl = ClustalwCommandline(clustal_loc,infile=f_in, outfile=f_out,score ="percent" , matrix="blosum" ,seqnos ="ON")
				#print cl.score
				
				assert os.path.isfile(clustal_loc), "Clustal W not found"
				
				stdout, stderr = cl()
				#cl().asequence
				#print stdout.AlignmentScore
				# print stdout
				
				# for line in stdout.split("\n"):
					# if 'Alignment Score' in line:
						# f_s.write('%s   %s\n ' % (line,possibleStartingPoints[xx][1]))
						# scr = line.split(' ')
						# maxAlignScoreIndex.append([scr[2],possibleStartingPoints[xx][1]])
		except:
				print("There was a problem aligning. Check ClustalW path and .fasta input.")
				
				
		fh.close()
		fo.close()
		# align = AlignIO.read(f_out, "clustal")
		# print(align)
			
	except:
		print("Could not parse. Check to make sure filepath is correct and that file is in   FASTA format")

def convertStockholmToFasta(file):
	
	print file
	filename = ""
	if len( file.split(".")) >2 :
		
		filename = file.split(".")[1]
	else:
		filename = file.split(".")[0]
	print filename
	outfile = "./%s.repbound" % filename
	filename = "./%s.stockholm" % filename
	print (filename,outfile)
	#exit()
	handle = open(filename, "rU")
	bestAlignRepeats = list(SeqIO.parse(handle, "stockholm"))
	handle.close()
	# bestAlignRepeats.sort(key=lambda window: int(window.id.split("-")[0]))
	#outfile = "%s.repbound" % filename
	handle = open(outfile, "w")
	SeqIO.write(bestAlignRepeats, handle, "fasta")
	handle.close()
	handle = open(outfile, "r")
	bestAlignRepeats = list(SeqIO.parse(handle, "fasta"))
	for i in range(0,len(bestAlignRepeats)):

		bestAlignRepeats[i].id = bestAlignRepeats[i].id.split("/")[-1]
		print bestAlignRepeats[i].id
	handle.close()
	handle = open(outfile, "w")
	SeqIO.write(bestAlignRepeats, handle, "fasta")
	handle.close()
	
	
def hmmProfileMake(file):
	filename = file.split(".")[-2]
	print (file,filename)
	commandBuild = "hmmbuild %s.hmm %s" % (filename,file)
	print commandBuild
	thread1 = hmmThread(1, "Thread-hmmBuild", 1,commandBuild)
	thread1.start()
	thread1.join()
	
	# commandSearch = "hmmsearch -A %s.stockholm %s.hmm %s.fasta" % (filename,filename,filename)
	# thread1 = hmmThread(2, "Thread-hmmSearch", 2,commandSearch)
	# thread1.start()
	# thread1.join()
	# print "shjgdashjgdsha  %s.stockholm" % filename
	# #filename = "out"
	# convertStockholmToFasta("%s.stockholm" % filename)